Subject: Re: [PATCH net-next] bpf, skb_do_redirect: clear sender_cpu before xmit

From: Alexei Starovoitov <[email-masked]>
Date: Thu, 8 Oct 2015 19:35:01 -0700

On 10/8/15 5:50 PM, Devon H. O'Dell wrote:
>> with the amount of skb_sender_cpu_clear() all over the code base
>> >I wonder whether there is a better solution to all of these.
> I think there is. We found that splitting the union of sender_cpu and
> napi_id solved the issue for us. In general, I think this is an OK
> solution as long as the following hold:
>
>   * skbs are always allocated via kzalloc
>   * out -> out cloned skbs are always cloned on the same CPU
>   * an extra four bytes in skbuff isn't a bad thing

I'm pretty sure extending sk_buff for this is not acceptable.
I was thinking may be we can use sign bit to distinguish between
napi_id and sender_cpu.
Like:
         if ((int)skb->sender_cpu >= 0)
                 skb->sender_cpu = - (raw_smp_processor_id() + 1);
and inside get_xps_queue() use it only if it's negative.
Then we can remove skb_sender_cpu_clear() from everywhere.
Adding a check to napi_hash_add() to make sure that napi_id is not
negative is probably ok too.
Thoughts?